//go:build darwin || freebsd || linux || windows

package yu_sys

type Code byte

const (
	Gbk Code = iota
	Unicode
)

type S struct {
	// Code
	//
	//	@Description: 要将字符串转换为哪种编码，转换后会自动在尾部补充 \x00 结束符
	//	 utf8 请直接传递 string，无需此高级类型，utf8 请自行决定是否在尾部补充 \x00 结束符
	Code Code

	// Utf8
	//
	//	@Description: 欲转换的 utf8 字符串
	Utf8 string
}

type Address uintptr

func (t Address) CallInt(args ...any) int {
	j_i, _, _ := t.Call(args...)
	return int(j_i)
}

func (t Address) CallInt32(args ...any) int32 {
	j_i, _, _ := t.Call(args...)
	return int32(j_i)
}

func (t Address) CallUint(args ...any) uint {
	j_i, _, _ := t.Call(args...)
	return uint(j_i)
}

func (t Address) CallUint32(args ...any) uint32 {
	j_i, _, _ := t.Call(args...)
	return uint32(j_i)
}

func (t Address) CallBool(args ...any) bool {
	j_i, _, _ := t.Call(args...)
	return j_i == 1
}

func (t Address) CallUintptr(args ...any) uintptr {
	j_i, _, _ := t.Call(args...)
	return j_i
}

type Module uintptr
